//(c) 2016 Dmitry Grinberg   http://dmitry.gr   me@dmitry.gr   see LICENSE.txt

#include "hid.h"
#include <avr/pgmspace.h>





static const uint8_t PROGMEM usbDescriptorHidReportData[] =
{
    0x06, 0x00, 0xFF,                									// Usage Page = 0xFF00 (Vendor Defined Page 1)
	0x09, 0x01,															// USAGE (Vendor Usage 1)
	0xa1, 0x01,															// COLLECTION (Application)
	0x19, 0x01,															//      Usage Minimum
    0x2a, (uint8_t)HID_DATA_OUT_SZ, (uint8_t)(HID_DATA_OUT_SZ >> 8),	//      Usage Maximum
	0x15, 0x00,															//   LOGICAL_MINIMUM (0)
	0x26, 0xff, 0x00,													//   LOGICAL_MAXIMUM (255)
	0x75, 0x08,															//   REPORT_SIZE (8)
	0x96, (uint8_t)HID_DATA_OUT_SZ, (uint8_t)(HID_DATA_OUT_SZ >> 8),	//   REPORT_COUNT (HID_DATA_OUT_SZ)
	0x81, 0x00,															//      Input (Data, Array, Abs): Instantiates input packet fields based on the above report size, count, logical min/max, and usage.
	
	0x19, 0x01,															//      Usage Minimum
    0x2a, (uint8_t)HID_DATA_OUT_SZ, (uint8_t)(HID_DATA_OUT_SZ >> 8),	//      Usage Maximum
    
	0x91, 0x00,                        									//      Output (Data, Array, Abs): Instantiates output packet fields.
    0xc0,																// END_COLLECTION
};



void LinkError_DataDescrSizeWrong();


uint8_t hidGetDescrData(const uint8_t** descrP){
	
	if(HID_DESCR_SZ_DATA != sizeof(usbDescriptorHidReportData)) LinkError_DataDescrSizeWrong();

	*descrP = usbDescriptorHidReportData;
	return sizeof(usbDescriptorHidReportData);
}
